<template>
   <q-page class="flex flex-center">
 <q-btn class="absolute-top-right" flat round dense :icon="btnIcon" @click="changeFormaat()">
        <q-tooltip>{{toolTipNaam}}</q-tooltip>
      </q-btn>
     <AfdelingComponent
      v-for="kamer in kamers" :key="randomId(kamer.id)"
      v-bind:kamer="kamer"
      :Type="getType"
      v-bind:patientId="kamer.patient"
      v-on:goToPatient="goToPatient"
      v-on:pushToArray="alarm"
    ></AfdelingComponent>

  </q-page>

</template>

<script>
import AfdelingComponent from '../components/AfdelingComponent'
import KamerService from '../services/KamerService'
import ErrorService from '../services/ErrorService'

var audio = new Audio(require('../assets/alarm.wav'))
audio.loop = true
audio.muted = false
export default {
  name: 'Afdeling',
  components: {
    AfdelingComponent
  },
  data () {
    return {
      afdelingId: this.$route.params.id,
      kamers: [],
      polling: null,
      type: 'list',
      btnIcon: 'map',
      toolTipNaam: 'map',
      arrayAlarm: [], // bevat true/false dat afhangt of er een drempelwaarde werd overgeschreden
      settings: this.$store.getters['settings/settings']
    }
  },
  methods: {
    // indien er een drempelwaarde is overgeschreden bij 1 van de patienten zal er een alarm afgaan.Array zit met booleans waarop er dan wordt gefilterd of er true tussen zit
    alarm (bool) {
      this.arrayAlarm.push(bool)
      let alarmFilter = this.arrayAlarm.filter(getAlarm)
      if (alarmFilter.length !== 0) {
        if (this.settings.geluid) {
          this.playSound()
        }
      } else {
        this.stopSound()
      }
    },
    // methodes om het alarm geluid te laten afspelen/stoppen
    playSound () {
      audio.muted = false
      audio.play()
    },
    stopSound () {
      audio.pause()
      audio.muted = true
    },
    // niet de allerbeste manier maar dit is omdat de array niet update doordat de key steeds hetzelfde blijft (documentatie ook erbij gehaald en heeft ook niet geholpen)
    randomId (id) {
      return Math.floor(Math.random() * 10000) + id
    },

    // type van weergave veranderen
    changeFormaat: function () {
      if (this.type === 'map') {
        this.btnIcon = 'map'
        this.lijstView = false
        this.toolTipNaam = 'Map'
        this.type = 'list'
      } else {
        this.btnIcon = 'view_list'
        this.lijstView = true
        this.toolTipNaam = 'Lijst'
        this.type = 'map'
      }
    },
    loadKamers () {
      this.polling = setInterval(this.getKamers, 10000)
    },
    goToPatient (id) {
      if (id !== null) {
        this.$router.push({ path: `/patient/${id}` })
      }
    },
    async getKamers () {
      this.arrayAlarm = []
      console.log('refresh')
      try {
        this.kamers = await this.kamerservice.getByAfdelingId(this.afdelingId)
      } catch (error) {
        ErrorService.showAlert('Laden kamers mislukt')
      }
    }
  },
  // vooraleer je de pagina verlaat zal het geluid stoppen anders blijft het doorgaan
  beforeRouteLeave (to, from, next) {
    this.stopSound()
    next()
  },
  created () {
    this.kamerservice = new KamerService()
    this.getKamers()
    this.loadKamers()
  },
  beforeDestroy () {
    this.stopSound()
    clearInterval(this.polling)
  },
  watch: {
    // er wordt naar de route gekeken. Indien de route verandert van afdeling 1 naar 2 zal er een call worden gedaan naar de json server met de nieuwe afdelings id
    $route (to, from) {
      this.stopSound()
      this.afdelingId = to.params.id
      this.getKamers()
    },
    type () {
      return this.type
    }
  },
  computed: {
    getType: function () {
      return this.type
    }
  }
}
function getAlarm (bool) {
  return bool === true
}
</script>
